// FormatBUFR.h : header file for BUFR formatter
//

#pragma once

#include "decl.h"
#include "TelemetryTag.h"
#include "BUFR/BUFR_Table_B.h"

extern "C" TELEMETRY_DECL
TSelectionInfo g_siOriginatingCenters;

extern "C" TELEMETRY_DECL 
bool FormatBUFR(TData& dataMsg, TTelemetryTags& tags, CString strOriginatingCenter, CString strDataCategory, 
                CString strDataSubCategory, TTime tRef = TTime::GetCurrentTime());

extern "C" TELEMETRY_DECL
bool FormatBUFRAlarmTriggers(TData& dataMsg, TTelemetryTags& tags, CString strOriginatingCenter, 
                             CString strDataCategory, CString strDataSubCategory, 
                             ETagStates eCheckFlag=eTriggered, ETagStates eSetFlag=eFormatted);

extern TELEMETRY_DECL
CString TableBRefToString(const STRUCT_TABLE_B_REF& ref);

extern "C" TELEMETRY_DECL
void StringToTableBRef(LPCTSTR s, STRUCT_TABLE_B_REF& ref);

class TELEMETRY_DECL TBUFRTableB
{
public:
   // CSV file containing: F,X,Y,NAME,UNIT,SCALE,REFERENCE,BITS
   TBUFRTableB(char *szPathToTable = "\\Flash Disk\\BUFRTableB.txt");
   ~TBUFRTableB();
   STRUCT_TABLE_B_ELEMENT *GetTable() {return m_pTable;}
   int GetCount() {return m_iCount;}

protected:
   void Load();
   char *m_szPathToTable;
   STRUCT_TABLE_B_ELEMENT *m_pTable;
   int m_iCount;
};
