// Template.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <afxdllx.h>

#include "Template.h"
#include "TemplateBlock.h"
#include "TemplatePage.h"
#include "Xpert/Version.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// GetFileVersion()

extern "C" _declspec(dllexport) LPCTSTR GetFileVersion()
{
   // TODO: Update the library version by updating the return value below.
   // This value is displayed by Xpert in its "About" dialog.
   return FILE_VERSION_TSTRING;
}


/////////////////////////////////////////////////////////////////////////////
// DllMain()

AFX_EXTENSION_MODULE TemplateSLL = { NULL, NULL };

extern "C" int APIENTRY
DllMain(HANDLE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		TRACE0("TEMPLATE.SLL Initializing!\n");
		
		// Extension DLL one-time initialization
		if (!AfxInitExtensionModule(TemplateSLL, (HINSTANCE)hInstance))
			return 0;

		// Insert this DLL into the resource chain
		// NOTE: If this Extension DLL is being implicitly linked to by
		//  an MFC Regular DLL (such as an ActiveX Control)
		//  instead of an MFC application, then you will want to
		//  remove this line from DllMain and put it in a separate
		//  function exported from this Extension DLL.  The Regular DLL
		//  that uses this Extension DLL should then explicitly call that
		//  function to initialize this Extension DLL.  Otherwise,
		//  the CDynLinkLibrary object will not be attached to the
		//  Regular DLL's resource chain, and serious problems will
		//  result.

		new CDynLinkLibrary(TemplateSLL);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
	{
		TRACE0("TEMPLATE.SLL Terminating!\n");
		// Terminate the library before destructors are called
		AfxTermExtensionModule(TemplateSLL);
	}
	return 1;   // ok
}


/////////////////////////////////////////////////////////////////////////////
// TFactory plug-in

#include "Engine/Factory.h"

TFactory::TFactory()
{
   static TCHAR* Modules[] = {_T("TemplateBlock")};
   ModuleCount = 1;
   ModuleList = Modules;

   static TCHAR* Pages[]={_T("TemplatePage")};
   PageCount = 1;
   PageList = Pages;
}


TModule* TFactory::CreateModule(int Index)
{
   return dynamic_cast<TModule*>(new CTemplateBlock());
}


CModPropPage* TFactory::CreatePage(int Index)
{
   return dynamic_cast<CModPropPage*>(new CTemplatePage());
}

